%
% Our goal here is to cause a core dump, using lists.
%
% Note that "nil" and "cons" are internal symbols used by lists.

clear(interactive_mode).
set(insert_mode).

% 
%my_f1( cons(nil) ).
%my_f1( nil(cons) ).
%printf("Stage 1\n").

%my_f1( nil(nil) ).
%my_f1( cons(cons) ).
printf("Stage 2\n").

%my_f1( [2, cons, 3 | nil] ).
printf("Stage 3\n").
%?my_f1(X).

my_f1( [|0] ).
my_f1( [0|0] ).
my_f1( [0|] ).
?my_f1(A).


%my_f2( [|nil] ).
my_f2( [nil|nil] ).
%my_f2( [nil|] ).

%my_f2( [|cons] ).
%my_f2( [cons|nil] ).

%my_f2( [nil|cons] ).
%my_f2( [cons|] ).

% So, nesting is supposedly to arbitray depth?
my_f2( [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[0]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]] ).

?my_f2(B).


% These should fail
%?is_list( cons ), printf("cons is a list.\n").
? [2|5] = nil, printf("[2|5] = nil.\n").

quit.
