// *************************************************************************
//    SccEnv.h
// *************************************************************************

#ifndef _SccEnv_H_
#define _SccEnv_H_

#include "RMarkArray.h"
#include "RuleEnv.h"

// *************************************************************************

class Cor_SccInfo;

// *************************************************************************
// Holds run time data structures for SccInfo that need to be allocated
// at every module invocation.

class Cor_SccEnv {

  public:
    Cor_SccInfo    *parent_scc;
    Cor_RMarkArray *rm_Arr;
    int             numSNRules;
    Cor_RuleEnv   **snrule_envs;    // The size of this array is
                                    // parent_scc->numSNRules

    Cor_SccEnv(Cor_SccInfo *parent);
   ~Cor_SccEnv();

    void clear_tupits();
};

// *************************************************************************

#endif _SccEnv_H_
